image: docker:19.03.1

services:
  - docker:19.03.1-dind

variables:
  # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"

# Builds the docker image. $IMAGE_TAG must be set
.build_docker: &build_docker
  - echo "Creating docker image with tag $IMAGE_TAG."
  - docker pull $CI_REGISTRY_IMAGE:latest || true
  - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$IMAGE_TAG .
  - docker push $CI_REGISTRY_IMAGE:$IMAGE_TAG

before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

# Tag docker images with the ref name for feature branches.
# Ref names will have any forward slashes '/' converted to dashes '-'.
feature_branch:
  stage: build
  script:
    - IMAGE_TAG=$(echo $CI_COMMIT_REF_NAME | sed s@/@-@)
    - *build_docker
  only:
    - branches
  except:
    - /^master$/

release:
  stage: build
  script:
    - IMAGE_TAG=latest
    - *build_docker
  only:
    - master

tags:
  stage: build
  script:
    - IMAGE_TAG=$CI_COMMIT_TAG
    - *build_docker
  only:
    - tags
